import { ContainerMetricMessage, IModuleOptions, Module } from "../../container";
/** Abstract container metrics handler module. */
export declare abstract class Metrics extends Module {
    /** Default module name. */
    static readonly moduleName: string;
    constructor(options: IModuleOptions);
    /** Abstract handler for incoming metric messages. */
    protected abstract metricsOnMessage(metric: ContainerMetricMessage): void;
}
