import { ErrorChain } from "../../error";
/** NodeValidate error codes. */
export declare enum ENodeValidateError {
    IsBufferError = 0,
    IsFileError = 1,
    IsDirectoryError = 2
}
/** NodeValidate error chain class. */
export declare class NodeValidateError extends ErrorChain {
    constructor(code: ENodeValidateError, value?: any, cause?: Error);
}
