import { DateTime, DateTimeOptions } from "luxon";
import { Field } from "../field";
/** Validate.isDateTime options. */
export interface IIsDateTime extends DateTimeOptions {
}
/** Validate that value is a valid date and time parsed by 'luxon' library. */
export declare function isDateTime(value?: string, options?: IIsDateTime): DateTime;
export declare class DateTimeField extends Field<DateTime> {
    protected readonly options: IIsDateTime;
    constructor(options?: IIsDateTime);
    validate(value: string): DateTime;
    format(value: DateTime): string;
}
