import validator from "validator";
import { Field } from "../field";
/** Validate.isDomain options. */
export interface IIsDomain extends validator.IsFQDNOptions {
}
/** Wrapper for validator isFQDN. */
export declare function isDomain(value?: string, options?: IIsDomain): string;
export declare class DomainField extends Field<string> {
    protected readonly options: IIsDomain;
    constructor(options?: IIsDomain);
    validate(value: string): string;
}
