import validator from "validator";
import { Field } from "../field";
/** Validate.isEmail options. */
export interface IIsEmail extends validator.IsEmailOptions {
}
/** Wrapper for validator isEmail. */
export declare function isEmail(value?: string, options?: IIsEmail): string;
export declare class EmailField extends Field<string> {
    protected readonly options: IIsEmail;
    constructor(options?: IIsEmail);
    validate(value: string): string;
}
