import validator from "validator";
import { Field } from "../field";
/** Validate.isFloat options. */
export interface IIsFloat extends validator.IsFloatOptions {
}
/** Wrapper for validator isFloat. */
export declare function isFloat(value?: string, options?: IIsFloat): number;
export declare class FloatField extends Field<number> {
    protected readonly options: IIsFloat;
    constructor(options?: IIsFloat);
    validate(value: string): number;
}
