import validator from "validator";
import { Field } from "../field";
/** Validate.isHash options. */
export interface IIsHash {
    /** Hash algorithm to identifty, defaults to md5. */
    algorithm?: validator.HashAlgorithm;
}
/** Wrapper for validator isHash. */
export declare function isHash(value?: string, options?: IIsHash): string;
export declare class HashField extends Field<string> {
    protected readonly options: IIsHash;
    constructor(options?: IIsHash);
    validate(value: string): string;
}
