import validator from "validator";
import { Field } from "../field";
/** Validate.isInteger options. */
export interface IIsInteger extends validator.IsIntOptions {
}
/** Wrapper for validator isInt. */
export declare function isInteger(value?: string, options?: IIsInteger): number;
export declare class IntegerField extends Field<number> {
    protected readonly options: IIsInteger;
    constructor(options?: IIsInteger);
    validate(value: string): number;
}
