import validator from "validator";
import { Field } from "../field";
/** Validate.isPostalCode options. */
export interface IIsPostalCode {
    /** Locale used by validator, defaults to GB. */
    locale?: validator.PostalCodeLocale;
}
/** Wrapper for validator isPostalCode. */
export declare function isPostalCode(value?: string, options?: IIsPostalCode): string;
export declare class PostalCodeField extends Field<string> {
    protected readonly options: IIsPostalCode;
    constructor(options?: IIsPostalCode);
    validate(value: string): string;
}
