"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var error_1 = require("../../error");
/** NodeValidate error codes. */
var ENodeValidateError;
(function (ENodeValidateError) {
    ENodeValidateError[ENodeValidateError["IsBufferError"] = 0] = "IsBufferError";
    ENodeValidateError[ENodeValidateError["IsFileError"] = 1] = "IsFileError";
    ENodeValidateError[ENodeValidateError["IsDirectoryError"] = 2] = "IsDirectoryError";
})(ENodeValidateError = exports.ENodeValidateError || (exports.ENodeValidateError = {}));
/** NodeValidate error chain class. */
var NodeValidateError = /** @class */ (function (_super) {
    __extends(NodeValidateError, _super);
    function NodeValidateError(code, value, cause) {
        return _super.call(this, { name: ENodeValidateError[code], value: value }, cause) || this;
    }
    return NodeValidateError;
}(error_1.ErrorChain));
exports.NodeValidateError = NodeValidateError;
//# sourceMappingURL=validate.js.map