"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var error_1 = require("../error");
/** Validate error codes. */
var EValidateError;
(function (EValidateError) {
    EValidateError[EValidateError["IsAlphaError"] = 0] = "IsAlphaError";
    EValidateError[EValidateError["IsAlphanumericError"] = 1] = "IsAlphanumericError";
    EValidateError[EValidateError["IsAsciiError"] = 2] = "IsAsciiError";
    EValidateError[EValidateError["IsBase64Error"] = 3] = "IsBase64Error";
    EValidateError[EValidateError["IsBooleanError"] = 4] = "IsBooleanError";
    EValidateError[EValidateError["IsCountryError"] = 5] = "IsCountryError";
    EValidateError[EValidateError["IsCreditCardError"] = 6] = "IsCreditCardError";
    EValidateError[EValidateError["IsDateTimeError"] = 7] = "IsDateTimeError";
    EValidateError[EValidateError["IsDomainError"] = 8] = "IsDomainError";
    EValidateError[EValidateError["IsDurationError"] = 9] = "IsDurationError";
    EValidateError[EValidateError["IsEmailError"] = 10] = "IsEmailError";
    EValidateError[EValidateError["IsFloatError"] = 11] = "IsFloatError";
    EValidateError[EValidateError["IsHashError"] = 12] = "IsHashError";
    EValidateError[EValidateError["IsHexColourError"] = 13] = "IsHexColourError";
    EValidateError[EValidateError["IsHexadecimalError"] = 14] = "IsHexadecimalError";
    EValidateError[EValidateError["IsIntegerError"] = 15] = "IsIntegerError";
    EValidateError[EValidateError["IsIntervalError"] = 16] = "IsIntervalError";
    EValidateError[EValidateError["IsIpError"] = 17] = "IsIpError";
    EValidateError[EValidateError["IsJsonError"] = 18] = "IsJsonError";
    EValidateError[EValidateError["IsLanguageError"] = 19] = "IsLanguageError";
    EValidateError[EValidateError["IsLatitudeLongitudeError"] = 20] = "IsLatitudeLongitudeError";
    EValidateError[EValidateError["IsLocaleError"] = 21] = "IsLocaleError";
    EValidateError[EValidateError["IsMacAddressError"] = 22] = "IsMacAddressError";
    EValidateError[EValidateError["IsMimeTypeError"] = 23] = "IsMimeTypeError";
    EValidateError[EValidateError["IsMobilePhoneError"] = 24] = "IsMobilePhoneError";
    EValidateError[EValidateError["IsMongoIdError"] = 25] = "IsMongoIdError";
    EValidateError[EValidateError["IsPortError"] = 26] = "IsPortError";
    EValidateError[EValidateError["IsPostalCodeError"] = 27] = "IsPostalCodeError";
    EValidateError[EValidateError["IsStringError"] = 28] = "IsStringError";
    EValidateError[EValidateError["IsTimeZoneError"] = 29] = "IsTimeZoneError";
    EValidateError[EValidateError["IsUrlError"] = 30] = "IsUrlError";
    EValidateError[EValidateError["IsUuidError"] = 31] = "IsUuidError";
})(EValidateError = exports.EValidateError || (exports.EValidateError = {}));
/** Validate error chain class. */
var ValidateError = /** @class */ (function (_super) {
    __extends(ValidateError, _super);
    function ValidateError(code, value, cause) {
        return _super.call(this, { name: EValidateError[code], value: value }, cause) || this;
    }
    return ValidateError;
}(error_1.ErrorChain));
exports.ValidateError = ValidateError;
//# sourceMappingURL=validate.js.map