import { Field } from "../field";
/** Validate.isBoolean options. */
export interface IIsBoolean {
    /** If true, strict validation is used. */
    strict?: boolean;
}
/** Wrapper for validator toBoolean. */
export declare function isBoolean(value?: string, options?: IIsBoolean): boolean;
export declare class BooleanField extends Field<boolean> {
    protected readonly options: IIsBoolean;
    constructor(options?: IIsBoolean);
    validate(value: string): boolean;
}
