import { Duration, DurationOptions } from "luxon";
import { Field } from "../field";
/** Validate.isDuration options. */
export interface IIsDuration extends DurationOptions {
}
/** Validate that value is a valid duration parsed by 'luxon' library. */
export declare function isDuration(value?: string, options?: IIsDuration): Duration;
export declare class DurationField extends Field<Duration> {
    protected readonly options: IIsDuration;
    constructor(options?: IIsDuration);
    validate(value: string): Duration;
    format(value: Duration): string;
}
