"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var validator_1 = require("validator");
var field_1 = require("../field");
var validate_1 = require("../validate");
/** Wrapper for validator isHexColor. */
function isHexColour(value) {
    if (value === void 0) { value = ""; }
    try {
        if (validator_1.default.isHexColor(value) !== true) {
            throw new validate_1.ValidateError(validate_1.EValidateError.IsHexColourError, value);
        }
        return value;
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsHexColourError, value, error);
    }
}
exports.isHexColour = isHexColour;
var HexColourField = /** @class */ (function (_super) {
    __extends(HexColourField, _super);
    function HexColourField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HexColourField.prototype.validate = function (value) {
        return isHexColour(value);
    };
    return HexColourField;
}(field_1.Field));
exports.HexColourField = HexColourField;
//# sourceMappingURL=is-hex-colour.js.map