import { Field } from "../field";
/** Validate.isIp options. */
export interface IIsIp {
    /** IP version number, defaults to 4. */
    version?: "4" | "6";
}
/** Wrapper for validator isIP. */
export declare function isIp(value?: string, options?: IIsIp): string;
export declare class IpField extends Field<string> {
    protected readonly options: IIsIp;
    constructor(options?: IIsIp);
    validate(value: string): string;
}
