"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var validator_1 = require("validator");
var field_1 = require("../field");
var validate_1 = require("../validate");
/** Wrapper for validator isMACAddress. */
function isMacAddress(value) {
    if (value === void 0) { value = ""; }
    try {
        if (validator_1.default.isMACAddress(value) !== true) {
            throw new validate_1.ValidateError(validate_1.EValidateError.IsMacAddressError, value);
        }
        return value;
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsMacAddressError, value, error);
    }
}
exports.isMacAddress = isMacAddress;
var MacAddressField = /** @class */ (function (_super) {
    __extends(MacAddressField, _super);
    function MacAddressField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MacAddressField.prototype.validate = function (value) {
        return isMacAddress(value);
    };
    return MacAddressField;
}(field_1.Field));
exports.MacAddressField = MacAddressField;
//# sourceMappingURL=is-mac-address.js.map