"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var validator_1 = require("validator");
var field_1 = require("../field");
var validate_1 = require("../validate");
/** Wrapper for validator isMimeType. */
function isMimeType(value) {
    if (value === void 0) { value = ""; }
    try {
        if (validator_1.default.isMimeType(value) !== true) {
            throw new validate_1.ValidateError(validate_1.EValidateError.IsMimeTypeError, value);
        }
        return value;
    }
    catch (error) {
        throw new validate_1.ValidateError(validate_1.EValidateError.IsMimeTypeError, value, error);
    }
}
exports.isMimeType = isMimeType;
var MimeTypeField = /** @class */ (function (_super) {
    __extends(MimeTypeField, _super);
    function MimeTypeField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MimeTypeField.prototype.validate = function (value) {
        return isMimeType(value);
    };
    return MimeTypeField;
}(field_1.Field));
exports.MimeTypeField = MimeTypeField;
//# sourceMappingURL=is-mime-type.js.map