import validator from "validator";
import { Field } from "../field";
/** Validate.isUrl options. */
export interface IIsUrl extends validator.IsURLOptions {
}
/** Wrapper for validator isURL. */
export declare function isUrl(value?: string, options?: IIsUrl): string;
export declare class UrlField extends Field<string> {
    protected readonly options: IIsUrl;
    constructor(options?: IIsUrl);
    validate(value: string): string;
}
