import { Field } from "../field";
/** Validate.isUuid options. */
export interface IIsUuid {
    /** UUID version number, defaults to all. */
    version?: 3 | 4 | 5 | "all";
}
/** Wrapper for validator isUUID. */
export declare function isUuid(value?: string, options?: IIsUuid): string;
export declare class UuidField extends Field<string> {
    protected readonly options: IIsUuid;
    constructor(options?: IIsUuid);
    validate(value: string): string;
}
